! This file is part of SusHi.
! 
! It includes the input and output routines of SusHi.
! 
C-{{{ subroutine readinsushi

      subroutine readinsushi(fhflag,thdmcflag,extflag)

      implicit none

      logical fhflag,thdmcflag
      logical ifilein, ppcoll,extflag
      double precision mapreal8,mapreal8def
      integer mapint,mapintdef
      integer count1, count2, blockflag, rensbotc
      character blocks(20)*15, bltype*15

      include '../commons/common-inputoutput.f'
      !internal definitions
      include '../commons/common-keys.f'
      include '../commons/common-slha.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'
      include '../commons/common-ren.f'
      include '../commons/common-quark.f'
      include '../commons/common-int.f'
      include '../commons/common-vegpar.f'

      common /coll/ ppcoll

      inquire(file=jfilein,exist=ifilein)
      if(.not.ifilein)then
         call printerrorsushi(1,6,'ERROR: FILE '//jfilein/
     &        /' DOES NOT EXIST!')
      endif
      open(unit=12,file=jfilein)

      fhflag  = .false.
      thdmcflag = .false.
      lcchkey = .false.

!     setting read-in-flags to false
      do count1=1,20
         blocks(count1) = ' '
      enddo
      do count1=1,100
         lsmassbo(count1)   = .false.
         lsmassfe1(count1)  = .false.
         lsmassfe2(count1)  = .false.
         lsminputs(count1)  = .false.
         lminpar(count1)    = .false.
         lsushipar(count1)  = .false.
      enddo
      do count1=1,60
         ldistribpar(count1) = .false.
         lextpar(count1)    = .false.
      enddo
      do count1=1,2
         do count2=1,2
            lstopmix(count1,count2) = .false.
         enddo
      enddo
      do count1=1,10
         lvegaspar(count1)      = .false.
         lvegaspar(10+count1)      = .false.
         lyukawafac(count1)     = .false.
         lfourgen(count1)       = .false.
         lfeynhiggspar(count1)  = .false.
         lscalespar(count1)     = .false.
         lrenormbotpar(count1)  = .false.
         lrenormsbotpar(count1) = .false.
      enddo
      lslhaalpha = .false.

      !read in of the main parameters for SUSHI
      do count1=1,20
         blocks(count1) = ' '
      enddo
      blocks(1) = 'SUSHI'
      call readblocks(12,blocks)

      !SUSHI parameters
      model = sushipar(1)
      if (sushipar(2).eq.0) then
         pseudo = 0 !internal light Higgs
      else if (sushipar(2).eq.1) then
         pseudo = 1 !internal pseudoscalar
      else if (sushipar(2).eq.2) then
         pseudo = 2 !internal heavy Higgs
      else
         call printerrorsushi(1,6
     &        ,'Please specify the Higgs under consideration.')
      endif

      if(sushipar(7).eq.1) then
         ew = 1
      else if (sushipar(7).eq.2) then
         ew = 2
      else
         ew = 0
      endif

      verbose = mapreal8def(sushipar(19),lsushipar(19),1.d0
     & ,'Normal output.')
      if(.not.extflag) then
         call printcopysushi(1,6,verbose)
      else
         call printcopysushi(0,6,verbose)
      endif
      nsubprocggh = mapreal8def(sushipar(20),lsushipar(20),0.d0
     & ,'All ggh@nnlo subprocesses included.')


      !---MSSM
      if (model.eq.1) then
      !looking for the block FEYNHIGGS
         bltype = 'FEYNHIGGS'
         call readslha(12,bltype,blockflag)

         if(blockflag.eq.1) then
            call printinfosushi(6,
     &           "SusHi was called with the SLHA-block 'FEYNHIGGS':")
            call printinfosushi(6,
     &           "Thus FeynHiggs is used for the calculation of SUSY")
            call printinfosushi(6,
     &           "Higgs masses, mu and stop, sbottom masses/angles.")
            fhflag  = .true.
         end if

      !read-in not dependent on FH-use
         do count1=1,20
            blocks(count1) = ' '
         enddo
         blocks(1) = 'SUSHI'
         blocks(2) = 'SMINPUTS'
         blocks(3) = 'MINPAR'
         blocks(4) = 'EXTPAR'
         blocks(5) = 'RENORMBOT'
         blocks(6) = 'RENORMSBOT'
         blocks(7) = 'FACTORS'
         call readblocks(12,blocks)

         !read-in dependent on FH-use
         do count1=1,20
            blocks(count1) = ' '
         enddo

         if (.not.fhflag) then
           !blocks(1) = 'SBOTMIX'
           !blocks(1) = 'STOPMIX'
            blocks(1) = 'ALPHA'
            blocks(2) = 'MASS'
            call readblocks(12,blocks)
         else
            blocks(1) = 'FEYNHIGGS'
            call readblocks(12,blocks)
            mssmpart = 4
            fieldren = 0
            tanbren = 0
            higgsmix = 2
            p2approx = 4
            looplevel = 2
            runningMT = 1
            botResum = 1
            tlCplxApprox = 0
         end if

      !---2HDM
      else if (model.eq.2) then
!     looking for the block 2HDMC
         bltype = '2HDMC'
         call readslha(12,bltype,blockflag)
         if(blockflag.eq.1) then
            call printinfosushi(6,
     &           "The input file contains the block '2HDMC':")
            call printinfosushi(6,
     &           "Thus 2HDMC is used for the calculation of the")
            call printinfosushi(6,
     &           "Higgs masses and the quark Yukawa couplings.")
            thdmcflag  = .true.
         else
            thdmcflag  = .false.
         end if

      !read-in not dependent on 2HDMC-use:
         do count1=1,20
            blocks(count1) = ' '
         enddo
         blocks(1) = 'SUSHI'
         blocks(2) = 'SMINPUTS'
         blocks(3) = 'RENORMBOT'
         blocks(4) = 'FACTORS'
         call readblocks(12,blocks)

         !read-in dependent on 2HDMC-use
         do count1=1,20
            blocks(count1) = ' '
         enddo

         if (.not.thdmcflag) then
            blocks(1) = 'ALPHA'
            blocks(2) = 'MASS'
            blocks(3) = '2HDM'
            blocks(4) = 'MINPAR'
            call readblocks(12,blocks)
         else
            blocks(1) = '2HDMC'
            call readblocks(12,blocks)
         end if

      !---SM
      else if (model.eq.0) then

         bltype = 'FEYNHIGGS'
         call readslha(12,bltype,blockflag)

         if(blockflag.eq.1) then
            call printinfosushi(6,
     &           "SusHi was called with the SLHA-block"//
     &           "FEYNHIGGS in the SM:")
            call printinfosushi(6,"Thus FeynHiggs is used for"//
     &           "the calculation of a Higgs mass,")
            call printinfosushi(6,
     &           "however the Higgs is the SM Higgs!")
            fhflag  = .true.
         end if

         do count1=1,20
            blocks(count1) = ' '
         enddo
         if (.not.fhflag) then
            blocks(1) = 'SUSHI'
            blocks(2) = 'SMINPUTS'
            blocks(3) = 'MASS'
            blocks(4) = 'RENORMBOT'
            blocks(5) = 'FACTORS'
            call readblocks(12,blocks)
         else
            blocks(1) = 'SUSHI'
            blocks(2) = 'SMINPUTS'
            blocks(3) = 'MINPAR'
            blocks(4) = 'EXTPAR'
            blocks(5) = 'RENORMBOT'
            blocks(6) = 'RENORMSBOT'
            blocks(7) = 'FACTORS'
            blocks(8) = 'FEYNHIGGS'
            call readblocks(12,blocks)
            !standard flags for FH 2.9
            mssmpart = 4
            fieldren = 0
            tanbren = 0
            higgsmix = 2
            p2approx = 4
            looplevel = 2
            runningMT = 1
            botResum = 1
            tlCplxApprox = 0
!to be used for a fixed top mass within FH
!          runningMT = 0
         end if

      else
         write(*,105)
         write(*,*) 
     &"Error: We are sorry, but the specified model"
         write(*,*) 
     &"is no reasonable SusHi dish."
         write(*,105)
         stop
      end if

      !---Setting parameters

      !Standard model input parameters
      invAlfa=mapreal8(sminputs(1),lsminputs(1) ,'alpha_em undefined. ')
      GF = mapreal8(sminputs(2),lsminputs(2) ,'G_Fermi undefined. ')
      AlfasMZ=mapreal8(sminputs(3),lsminputs(3) ,'alphaSMZ undefined. ')
      MZ = mapreal8(sminputs(4),lsminputs(4),'Mz undefined. ')
      mbmb=mapreal8(sminputs(5),lsminputs(5),'bottom mass undefined. ')
      MT = mapreal8(sminputs(6),lsminputs(6),'top mass undefined. ')
      mt2 = mt**2
      MS = -1
      MC = -1
      ME = -1
      MU = -1
      MD = -1
      MM = -1
      MS = -1
      ML = -1

      !calculating mW from mZ, GF and alpha_EM
      mW = dsqrt(0.25D0- (1.D0/invAlfa) * Pi / (dsqrt(2.D0)*GF*mZ*mZ))
      mW = mZ * mZ * (0.5D0 + mW) / 0.985D0
      mW = dsqrt(mW)

      !---MSSM
      if ((model.eq.1).or.((model.eq.0).and.fhflag)) then
         !Minpar parameters
         tanb = mapreal8(minpar(3),lminpar(3),'tanb undefined. ')

         !SUSY parameters from extpar or external masses
         if (.not.fhflag) then
            Mgl = mapreal8(dabs(extpar(3)),lextpar(3)
     &     ,'gluino mass undefined. ')
            alpha = mapreal8(slhaalpha,lslhaalpha,'alpha undefined. ')
            muSUSY = mapreal8(extpar(23),lextpar(23),'mu undefined. ')
            M3SQ = mapreal8(extpar(43),lextpar(43),'M_SQ undefined. ')
            M3SU = mapreal8(extpar(46),lextpar(46),'M_SU undefined. ')
            M3SD = mapreal8(extpar(49),lextpar(49),'M_SD undefined. ')
            cAt = mapreal8(extpar(11),lextpar(11),'At undefined. ')
            cAb = mapreal8(extpar(12),lextpar(12),'Ab undefined. ')
            if (pseudo.eq.0) then
               Mh = mapreal8(smassbo(25),lsmassbo(25)
     &              ,'light Higgs mass undefined. ')
            else if (pseudo.eq.1) then
               Mh = mapreal8(smassbo(36),lsmassbo(36)
     &              ,'pseudoscalar mass undefined. ')
            else if (pseudo.eq.2) then
               Mh = mapreal8(smassbo(35),lsmassbo(35)
     &              ,'heavy Higgs mass undefined. ')
            end if
         else
            MUE = 
     &dcmplx(mapreal8(extpar(23),lextpar(23),'mu undefined. '))
            M3SQ = mapreal8(extpar(43),lextpar(43),'M_SQ undefined. ')
            M3SU = mapreal8(extpar(46),lextpar(46),'M_SU undefined. ')
            M3SD = mapreal8(extpar(49),lextpar(49),'M_SD undefined. ')
            cAt = mapreal8(extpar(11),lextpar(11),'At undefined. ')
            cAb = mapreal8(extpar(12),lextpar(12),'Ab undefined. ')
            M_3=dcmplx(mapreal8(extpar(3),lextpar(3),'M_3 undefined. '))
            MA0 = mapreal8(extpar(26),lextpar(26),'MA0 undefined. ')

            M_1=dcmplx(mapreal8(feynhiggspar(1),lfeynhiggspar(1),
     &'M_1 undefined. '))
            M_2=dcmplx(mapreal8(feynhiggspar(2),lfeynhiggspar(2),
     &'M_2 undefined. '))

            !Setting of trilinear couplings in FeynHiggs
            if (lfeynhiggspar(3)) then
            cAu = mapreal8(feynhiggspar(3),lfeynhiggspar(3),
     &'A for FH undefined. ')
            cAmu = cAu
            cAtau = cAu
            cAc = cAu
            cAs = cAu
            cAe = cAu
            cAd = cAu
            else
            cAtau = mapreal8(feynhiggspar(13),lfeynhiggspar(13),
     &'A_TAU for FH undefined. ')
            cAc = mapreal8(feynhiggspar(14),lfeynhiggspar(14),
     &'A_C for FH undefined. ')
            cAs = mapreal8(feynhiggspar(15),lfeynhiggspar(15),
     &'A_S for FH undefined. ')
            cAmu = mapreal8(feynhiggspar(16),lfeynhiggspar(16),
     &'A_MU for FH undefined. ')
            cAu = mapreal8(feynhiggspar(17),lfeynhiggspar(17),
     &'A_U for FH undefined. ')
            cAd = mapreal8(feynhiggspar(18),lfeynhiggspar(18),
     &'A_D for FH undefined. ')
            cAe = mapreal8(feynhiggspar(19),lfeynhiggspar(19),
     &'A_E for FH undefined. ')
            end if

            !Setting of soft-breaking masses in FeynHiggs
            if (lfeynhiggspar(4)) then
            MSUSY = mapreal8(feynhiggspar(4),lfeynhiggspar(4),
     &'MSUSY for FH undefined. ')
            M3SL = MSUSY
            M3SE = MSUSY
            M2SL = MSUSY
            M2SE = MSUSY
            M2SQ = MSUSY
            M2SU = MSUSY
            M2SD = MSUSY
            M1SL = MSUSY
            M1SE = MSUSY
            M1SQ = MSUSY
            M1SU = MSUSY
            M1SD = MSUSY
            else
            M3SL = mapreal8(feynhiggspar(33),lfeynhiggspar(33),
     &'M3SL for FH undefined. ')
            M3SE = mapreal8(feynhiggspar(36),lfeynhiggspar(36),
     &'M3SE for FH undefined. ')
            M2SL = mapreal8(feynhiggspar(32),lfeynhiggspar(32),
     &'M2SL for FH undefined. ')
            M2SE = mapreal8(feynhiggspar(35),lfeynhiggspar(35),
     &'M2SE for FH undefined. ')
            M2SQ = mapreal8(feynhiggspar(42),lfeynhiggspar(42),
     &'M2SQ for FH undefined. ')
            M2SU = mapreal8(feynhiggspar(45),lfeynhiggspar(45),
     &'M2SU for FH undefined. ')
            M2SD = mapreal8(feynhiggspar(48),lfeynhiggspar(48),
     &'M2SD for FH undefined. ')
            M1SL = mapreal8(feynhiggspar(31),lfeynhiggspar(31),
     &'M1SL for FH undefined. ')
            M1SE = mapreal8(feynhiggspar(34),lfeynhiggspar(34),
     &'M1SE for FH undefined. ')
            M1SQ = mapreal8(feynhiggspar(41),lfeynhiggspar(41),
     &'M1SQ for FH undefined. ')
            M1SU = mapreal8(feynhiggspar(44),lfeynhiggspar(44),
     &'M1SU for FH undefined. ')
            M1SD = mapreal8(feynhiggspar(47),lfeynhiggspar(47),
     &'M1SD for FH undefined. ')
            end if

         end if

      !---SM
      else if ((model.eq.0).and.(.not.fhflag)) then
         
         Mh = mapreal8(smassbo(25),lsmassbo(25)
     &        ,'scalar Higgs mass undefined. ')

      end if

!---  2HDM
      if (model.eq.2) then
         if (.not.thdmcflag) then
            twohdmver = mapreal8(twohdmpar,ltwohdmpar,
     &           '2HDM version undefined. ')
            tanb = mapreal8(minpar(3),lminpar(3),'tanb undefined. ')
            alpha = mapreal8(slhaalpha,lslhaalpha,'alpha undefined. ')
            if (pseudo.eq.0) then
               Mh = mapreal8(smassbo(25),lsmassbo(25)
     &              ,'light Higgs mass undefined. ')
            else if (pseudo.eq.1) then
               Mh = mapreal8(smassbo(36),lsmassbo(36)
     &              ,'pseudoscalar mass undefined. ')
            else if (pseudo.eq.2) then
               Mh = mapreal8(smassbo(35),lsmassbo(35)
     &              ,'heavy Higgs mass undefined. ')
            end if
         endif
      end if
         
!     some settings for FeynHiggs if used
      if ((model.eq.1).or.((model.eq.0).and.fhflag)) then
         CKMlambda = -1
         CKMA      = -1
         CKMrhobar = -1
         CKMetabar = -1
         
         scalefactor = 1.d0

         Qtau = 0.d0
         Qt = 0.d0
         Qb = 0.d0

         MHp = 0.d0
      end if

      !Yukawa factors
      yukfac(1)=mapreal8(yukawafac(1),lyukawafac(1),
     &     'charm yukawa-coupling undefined. ')
      yukfac(2)=mapreal8(yukawafac(2),lyukawafac(2),
     &     'top yukawa-coupling undefined. ')
      yukfac(3)=mapreal8(yukawafac(3),lyukawafac(3),
     &     'bottom yukawa-coupling undefined. ')

      if (model.eq.1) then
         yukfac(6)=mapreal8(yukawafac(4),lyukawafac(4),
     &'stop yukawa-coupling undefined. ')
         yukfac(7)=mapreal8(yukawafac(5),lyukawafac(5),
     &'sbottom yukawa-coupling undefined. ')
      else
         yukfac(6) = 0.d0
         yukfac(7) = 0.d0
      end if
      
      Mcharm = 1.28d0
      Mbp = 1000.d0
      Mtp = 1000.d0

      if(yukfac(1).ne.0.d0)
     & Mcharm = mapreal8(sminputs(8),lsminputs(8),
     & 'charm mass undefined. ')

      !4.Generation parameters
!Form of the corresponding block in the input files:
!Block 4GEN
!  1   3.00000000e+02   # Mb'
!  2   3.00000000e+02   # Mt'
!  3   0.d0             # factor for yukawa-couplings: t'
!  4   0.d0             # b'
!  5   0.d0             # st'
!  6   0.d0             # sb'
      bltype = '4GEN'
      call readslha(12,bltype,blockflag)
      if (blockflag.eq.1) then
         do count1=1,20
            blocks(count1) = ' '
         enddo
         blocks(1) = '4GEN'
         call readblocks(12,blocks)
         yukfac(4) = mapreal8(fourgen(3),lfourgen(3),
     &        'top yukawa-coupling undefined. ')
         yukfac(5) = mapreal8(fourgen(4),lfourgen(4),
     &        'bottom yukawa-coupling undefined. ')
         if (model.eq.1) then
            yukfac(8) = mapreal8(fourgen(5),lfourgen(5),
     &           'stop yukawa-coupling undefined. ')
            yukfac(9) = mapreal8(fourgen(6),lfourgen(6),
     &           'sbottom yukawa-coupling undefined. ')
         else
            yukfac(8) = 0.d0
            yukfac(9) = 0.d0
         end if
         if(yukfac(5).ne.0.d0)
     & Mbp = mapreal8(fourgen(1),lfourgen(1),'b mass undefined. ')
         if(yukfac(4).ne.0.d0)
     & Mtp = mapreal8(fourgen(2),lfourgen(2),'t mass undefined. ')
      else
         yukfac(4) = 0.d0
         yukfac(5) = 0.d0
         yukfac(8) = 0.d0
         yukfac(9) = 0.d0
      end if

      !bottom sector
      if (lrenormbotpar(1)) then
         mbrunyuk = renormbotpar(1)
      else
         mbrunyuk = 0
      endif

      if (lrenormbotpar(2)) then
         tanbresum = renormbotpar(2)
      if (model.eq.0) then
         write(*,105)
         write(*,*)
     &"Tan(b)-Resummation for the SM is not reasonable!"
         write(*,105)
      else
      if (mbrunyuk.gt.0) then
         write(*,105)
         write(*,*)
     &"Running bottom mass in the MSSM is always resummed!"
         write(*,105)
      endif
      endif
      else
         tanbresum = 0
      endif

      if (lrenormbotpar(3)) then
         delmbfh = renormbotpar(3)
      else
         delmbfh = 0
      endif

      if (lrenormbotpar(4)) then
         mbossave = renormbotpar(4)
      else
         mbossave = 0.D0
      endif

      if (lrenormbotpar(5)) then
         mbrunloop = renormbotpar(5)
      else
         mbrunloop = 0
      endif

      !sbottom sector
      if (model.eq.1) then
      !first check whether all flags are set
         if (.not.lrenormsbotpar(1)) then
            write(*,105)
            write(*,*)
     &"Please choose a scheme for mb in the sbottom sector!"
            write(*,105)
            stop
         end if
         if (.not.lrenormsbotpar(2)) then
            write(*,105)
            write(*,*)
     &"Please choose a scheme for Ab in the sbottom sector!"
            write(*,105)
            stop
         end if
         if (.not.lrenormsbotpar(3)) then
            write(*,105)
            write(*,*)
     &"Please choose a scheme for thetab in the sbottom sector!"
            write(*,105)
            stop
         end if

         rensbotc = 0
         do count1=1,3
            if (renormsbotpar(count1).eq.2) rensbotc = rensbotc + 1
         enddo
         if (rensbotc.ne.1) then
            write(*,105)
            write(*,*)
     &"Exactly one sbottom parameter has to be choosen -dependent-!"
            write(*,105)
            stop
         endif
         mbsbch = renormsbotpar(1)
         Abch = renormsbotpar(2)
         thetabch = renormsbotpar(3)
      endif

      !setting 2HDM back to MSSM
      if (model.eq.2) then
         tanbresum = 0
         mbsbch = 2
         Abch = 0
         thetabch = 0
      end if

      if(extflag) then
         norderggh = 1
         norderbbh = -1
         close(12)
      else
         norderggh = sushipar(5)
         norderbbh = sushipar(6)
         if (((norderbbh.ge.3).and.(norderbbh.le.9))
     &        .or.(norderbbh.ge.13).or.(norderbbh.le.-2)) then
            call printerrorsushi(1,6
     &           ,'Block SUSHI, entry 6 out of range.')
         endif
         if (norderbbh.ge.10) then
            lcchkey = .true.
            norderbbh=norderbbh-10
            mbmb=mapreal8(sminputs(5),lsminputs(5)
     &           ,'charm mass undefined. ')
         endif         

         blocks(1) = 'DISTRIB'
         blocks(2) = 'SCALES'
         blocks(3) = 'VEGAS'
         blocks(4) = 'PDFSPEC'
         call readblocks(12,blocks)

         SUpdfs(1) = pdfnamelo
         SUpdfs(2) = pdfnamenlo
         SUpdfs(3) = pdfnamennlo
         if (lpdfspecpar(4)) then
            call printwarnsushi(verbose,6
     &           ,'Block PDFSPEC, entry 4 defined:')
            call printwarnsushi(verbose,6,
     &           ' => overriding possible entries 11,12,13!')
            SUiset(1) = pdfspecpar(4)
            SUiset(2) = pdfspecpar(4)
            SUiset(3) = pdfspecpar(4)
         else
            SUiset(1) = mapint(pdfspecpar(11),lpdfspecpar(11)
     &           ,'PDF number undefined.')
            SUiset(2) = mapint(pdfspecpar(12),lpdfspecpar(12)
     &           ,'PDF number undefined.')
            SUiset(3) = mapint(pdfspecpar(13),lpdfspecpar(13)
     &           ,'PDF number undefined.')
         endif

         if(sushipar(3).eq.0) then
            ppcoll = .true.
         else
            ppcoll = .false.            
         endif
         cme = 
     &        mapreal8(sushipar(4),lsushipar(4),'cm-energy undefined. ')

         !scale choices
         murfactor = 
     &        mapreal8def(scalespar(1),lscalespar(1),1.d0,
     &        'Using default renormalization scale muR=mHiggs.')
         muffactor = 
     &        mapreal8def(scalespar(2),lscalespar(2),murfactor,
     &        'Using default factorization scale muF=muR.')
         murfacbbh = 
     &        mapreal8def(scalespar(11),lscalespar(11),murfactor,
     &        'Using common renormalization scale for ggh and bbh.')
         muffacbbh = 
     &        mapreal8def(scalespar(12),lscalespar(12),muffactor,
     &        'Using default muF=muR in bbh.')

         !scalespt determines whether muR = factor * Sqrt(mh^2+p_T^2)
         !should be used in case of p_T distributions.
         if (lscalespar(3)) then
            if (scalespar(3).eq.1) scalespt = .true.
         else
            scalespt = .false.
         endif

         if (lscalespar(4)) then
            muBfactor = scalespar(4)
         else
            muBfactor = 1.d0
         endif

         !distribution parameters
         dist = 0
         ptc = 0
         rapc = 0
         if (ldistribpar(1)) dist = distribpar(1)
         if (ldistribpar(2)) ptc = distribpar(2)
         if (ldistribpar(3)) rapc = distribpar(3)

c..   ltotinc = .true. : calculate total inclusive cross section
         ltotinc = .false.
         if ((dist.eq.0).and.(ptc.eq.0).and.(rapc.eq.0)) 
     &        ltotinc = .true.
         
         minptc = 0.d0
         minrapc = 0.d0
         if (ldistribpar(21)) minptc = distribpar(21)
         if (ldistribpar(22)) maxptc = distribpar(22)
         if (ldistribpar(31)) minrapc = distribpar(31)
         if (ldistribpar(32)) maxrapc = distribpar(32)

         if (ptc.ge.2) then
            maxptc = mapreal8(distribpar(22),ldistribpar(22),
     &           'max. value of pt undefined. ')
         endif
         if ((rapc.eq.1).or.(rapc.eq.3)) then
            maxrapc = mapreal8(distribpar(32),ldistribpar(32),
     &           'max. value of rapidity undefined. ')
         end if

         if ((dist.eq.1).or.(dist.eq.3)) then
            maxptc = mapreal8(distribpar(22),ldistribpar(22),
     &           'value of pt undefined. ')
         end if
         if ((dist.eq.2).or.(dist.eq.3)) then
            maxrapc = mapreal8(distribpar(32),ldistribpar(32),
     &           'value of rapidity undefined. ')
         end if
         
         pseudorap = .false.
         if(distribpar(4).eq.1) then
            pseudorap = .true.
         endif

         pty=.true.
         if(dist.eq.0) then
            pty = .false.
         endif

         acc=1.d-8
         lveg1sushi=.true.
         ncall1sushi=mapintdef(vegaspar(1),lvegaspar(1),10000,
     &        'Using default VEGAS ncall=10000.')
         itmx1sushi=mapintdef(vegaspar(2),lvegaspar(2),5,
     &        'Using default VEGAS itmx=5.')
         nprnvsushi=mapintdef(vegaspar(3),lvegaspar(3),10,
     &        'Using default VEGAS nprn=10.')
         ncall2sushi=mapintdef(vegaspar(11),lvegaspar(11),0,
     &        'VEGAS will be called only once.')
         if (ncall2sushi.gt.0) then
            itmx2sushi=mapintdef(vegaspar(12),lvegaspar(12),5,
     &           'Using default VEGAS itmx=5.')
         else
            lveg1sushi=.false.
            itmx2sushi=0
         endif

         lveg1ggh=.true.
         ncall1ggh=mapintdef(vegaspar(4),lvegaspar(4),2000,
     &        'Using default VEGAS ncall1=2000 for ggh.')
         itmx1ggh=mapintdef(vegaspar(5),lvegaspar(5),5,
     &        'Using default VEGAS itmx1=5 for ggh.')
         nprnvggh=mapintdef(vegaspar(6),lvegaspar(6),0,
     &        'Using default VEGAS nprnggh=0.')
         ncall2ggh=mapintdef(vegaspar(14),lvegaspar(14),5000,
     &        'Using default VEGAS ncall2=5000 for ggh.')
         if (ncall2ggh.eq.0) then
            lveg1ggh=.false.
            itmx2ggh=0
         else
            itmx2ggh=mapintdef(vegaspar(15),lvegaspar(15),2,
     &           'Using default VEGAS itmx2=2 for ggh.')
         endif
         
         lveg1bbh=.true.
         ncall1bbh=mapintdef(vegaspar(7),lvegaspar(7),2000,
     &        'Using default VEGAS ncall1=2000 for bbh.')
         itmx1bbh=mapintdef(vegaspar(8),lvegaspar(8),5,
     &        'Using default VEGAS itmx1=5 for bbh.')
         nprnvbbh=mapintdef(vegaspar(9),lvegaspar(9),0,
     &        'Using default VEGAS nprnbbh=0.')
         ncall2bbh=mapintdef(vegaspar(17),lvegaspar(17),5000,
     &        'Using default VEGAS ncall2=5000 for bbh.')
         if (ncall2bbh.eq.0) then
            lveg1bbh=.false.
            itmx2bbh=0
         else
            itmx2bbh=mapintdef(vegaspar(18),lvegaspar(18),2,
     &           'Using default VEGAS itmx2=2 for bbh.')
         endif

      if (verbose.eq.0) then
          nprnvsushi = 0
          nprnvggh = 0
          nprnvbbh = 0
      end if
         
      endif

 105  format('#--------------------------------------------------#')
      end

C-}}}
C-{{{ subroutine outputsushi

      subroutine outputsushi(fhflag,thdmcflag,delmb)

      implicit none

      logical fhflag,thdmcflag
      integer i
      logical ppcoll
      double precision delmb, gghnnloout(-1:5), gghnnloout2(-1:5)
      double precision effres, res, effres2
      character resstring*30, effresstring*30
      character effresstring2*30,bbhstring*3
      integer date_time(8)
      character realcl(3)*12

      include '../commons/common-inputoutput.f'
      !internal definitions

!defined at other places:
!AlfasMZ,muRfactor,muFfactor,cme,dist,prefix,prefix2,pty,iset
!norderggh,mw,mc,ew,mz,mbmb,renscheme,mt,pseudo,tanbresum,pseudorap
      include '../commons/common-slha.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'
      include '../commons/common-ren.f'
      include '../commons/common-quark.f'
      include '../commons/common-int.f'
      include '../commons/common-citations.f'
      include '../commons/common-keys.f'
      include '../commons/common-vegpar.f'
      include '../commons/common-bbhnnlo.f'

      common /coll/ ppcoll
c$$$      common /bveg1/ xl,xu,acc,ndm,ncall,itmx,nprn



      open(unit=13,file=jfnameact,status='unknown')

      bbhstring = 'bbh'
      if (lcchkey) bbhstring = 'cch'

      call printcopysushi(0,13,verbose)

      call date_and_time(realcl(1),realcl(2),realcl(3),date_time)

      write (13,106) date_time(3), date_time(2), date_time(1),
     &date_time(5), date_time(6), date_time(7)

      write(13,103)
     &"# For the reconstructed input file, check below.   #"
      write(13,103)
     &"#--------------------------------------------------#"
      if ((ew.eq.1).and.(norderggh.ge.1)) then
         citations(11) = 1
         citations(12) = 1
      endif
      if ((ew.eq.2).and.(norderggh.ge.1).and.
     &((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0))) then
         citations(10) = 1
      endif
      if(norderggh.ge.1) then
         citations(26) = 1
         citations(20) = 2
         citations(21) = 2
         citations(22) = 2
      endif
      write(13,"(a)")
     &"# Please cite the following papers (for this run):"
      call printcite(13,1,'# ')
      write(13,103)
     &"#--------------------------------------------------#"

      !most important results
      if ((dist.eq.0).or.(dist.eq.2)) then
         effresstring = "ggh XS in pb"
         resstring = "ggh XS in pb"
      else
         effresstring = "ggh XS in pb/GeV"
         resstring = "ggh XS in pb/GeV"
      endif

c.. res is obsolete now (10 Mar 2014):      
      effres = xeff
      if (norderggh.eq.0) effres = xsec(1)
      res = xsec(1)
      if (norderggh.ge.1) then
         res = xsec(2)
      endif

      write(13,103) 'Block SUSHIinfo'
      write(13,1023) 1,SUversion,'SusHi version'
      if (norderggh.ge.0) then
         write(13,103) 
     &        "Block SUSHIggh # Bon appetit"
            write(13,102) 1,effres,effresstring
            if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
               write(13,103) 
     &        "# Note: Fixed order p_T distribution (no resummation)!"
               write(13,103) "# p_T < 20 GeV not reasonable!"
            endif
      endif
      
      if (norderbbh.eq.0) then
         effres2 = SUbbh(1)
      else if (norderbbh.ge.0) then
         effres2 = SUbbh(2)
      end if
      if (norderbbh.eq.2) then
         if (.not.((ptc.gt.0).or.(rapc.gt.0))) then
            effres2 = SUbbh(3)
         end if
      end if
      effresstring2 = bbhstring//' XS in pb'

      if ((norderbbh.ge.0).and.(dist.eq.0)) then
         write(13,103) 
     &        "Block SUSHIbbh # Bon appetit"
         write(13,102) 1,effres2,effresstring2
         if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
            write(13,103) 
     &        "# Note: Fixed order p_T distribution (no resummation)!"
            write(13,103) "# p_T < 20 GeV not reasonable!"
         endif
      endif
      
      
      do i=-1,5
         if ((norderggh.ne.3).or.(pseudo.ne.0)) then
            gghnnloout(i) = SUggh(2,i) * gt3**2
            gghnnloout2(i) = SUggh(3,i) * gt3**2
         else
            gghnnloout(i) = SUggh(2,i)
            gghnnloout2(i) = SUggh(3,i)
         endif
      enddo

      !detailled output
      !SM ggh
      if (norderggh.ge.0) then
         if ((dist.eq.0).or.(dist.eq.2)) then
          write(13,103) 
     &           "Block XSGGH # ggh cross sec. in pb (w/o EW)"
         else
            write(13,103)
     &           "Block XSGGH # ggh cross sec. in pb/GeV  (w/o EW)"
         endif
         if (norderggh.eq.0) then
            write(13,102) 1,xsec(1),"LO"
         elseif (norderggh.ge.1) then
            write(13,102) 1,xsec(1),"LO w/ NLO PDFs"
            write(13,102) 2,xsec(2),"NLO"
            write(13,102) 21,ggchan,"NLO gg"
            write(13,102) 22,qgchan,"NLO qg"
            write(13,102) 23,qqchan,"NLO qq"
         endif
         write(13,103) "Block XSGGHEFF # ggh xsec"
         if (ltotinc) then
            if (norderggh.ge.1) then
               write(13,102) 1,gghnnloout(0),"ggh@NLO"
               if (nsubprocggh.eq.10) then
!     ggh@nnlo computed all subchannels separately:
                  write(13,102) 10,gghnnloout(-1),"ggh@NLO: soft+virt"
                  write(13,102) 11,gghnnloout(1),"ggh@NLO: gg-channel"
                  write(13,102) 12,gghnnloout(2),"ggh@NLO: qg-channel"
                  write(13,102) 13,gghnnloout(3),"ggh@NLO: qqb-channel"
               endif
            endif
            if (norderggh.ge.2) then
               write(13,102) 2,gghnnloout2(0),"ggh@NNLO"
               if (nsubprocggh.eq.10) then
!     ggh@nnlo computed all subchannels separately:
                  write(13,102) 20,gghnnloout2(-1)
     &                 ,"ggh@NNLO: soft+virt"
                  write(13,102) 21,gghnnloout2(1)
     &                 ,"ggh@NNLO: gg-channel"
                  write(13,102) 22,gghnnloout2(2)
     &                 ,"ggh@NNLO: qg-channel"
                  write(13,102) 23,gghnnloout2(3)
     &                 ,"ggh@NNLO: qqb-channel"
                  write(13,102) 24,gghnnloout2(4)
     &                 ,"ggh@NNLO: qq-channel"
                  write(13,102) 25,gghnnloout2(5)
     &                 ,"ggh@NNLO: qu-channel"
               endif
            endif
         endif
         write(13,102) 3,elw,"electroweak factor"
      endif
      
      !SM MSSM bbh
      if (norderbbh.ge.0) then
         if (dist.eq.0) then
            write(13,103) 'Block XSBBH # '//bbhstring/
     &           /' Cross sec. in pb'
            write(13,102) 1,SUbbh(1),"LO"
            if (norderbbh.gt.0) then
               write(13,102) 2,SUbbh(2),"NLO"
            end if
            if (norderbbh.gt.1) then
               if ((ptc.eq.0).and.(rapc.eq.0)) then
                  write(13,102) 3,SUbbh(3),"NNLO"
               end if
            end if
         endif
      endif

      !effective couplings in MSSM
      if (model.ge.1) then
         if (pseudo.eq.0) then
            write(13,103) 
     &"Block HGGSUSY # couplings of light Higgs h to 3. generation"
         else if (pseudo.eq.1) then
            write(13,103) 
     &"Block HGGSUSY # couplings of pseudoscalar A to 3. generation"
         else if (pseudo.eq.2) then
            write(13,103) 
     &"Block HGGSUSY # couplings of heavy Higgs H to 3. generation"
         end if
         write(13,102) 101,gt3,'g_t^phi'
         if (model.eq.1) then
            write(13,102) 111,gt13,'g_st11^phi'
            write(13,102) 122,gt23,'g_st22^phi'
            write(13,102) 112,gth123,'g_st12^phi'
            write(13,102) 121,gth213,'g_st21^phi'
         end if
         write(13,102) 201,gb3,'g_b^phi'
         if (model.eq.1) then
            write(13,102) 211,gb13,'g_sb11^phi'
            write(13,102) 222,gb23,'g_sb22^phi'
            write(13,102) 212,gbh123,'g_sb12^phi'
            write(13,102) 221,gbh213,'g_sb21^phi'
         end if
         if((yukfac(4).ne.0.d0).or.(yukfac(5).ne.0.d0)) then
            if (pseudo.eq.0) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of light Higgs h to 4. generation"
            else if (pseudo.eq.1) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of pseudoscalar A to 4. generation"
            else if (pseudo.eq.2) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of heavy Higgs H to 4. generation"
            end if
            write(13,102) 101,gt4,'g_t^phi'
            if (model.eq.1) then
            write(13,102) 111,gt14,'g_st11^phi'
            write(13,102) 122,gt24,'g_st22^phi'
            write(13,102) 112,gth124,'g_st12^phi'
            write(13,102) 121,gth214,'g_st21^phi'
            end if
            write(13,102) 201,gb4,'g_b^phi'
            if (model.eq.1) then
            write(13,102) 211,gb14,'g_sb11^phi'
            write(13,102) 222,gb24,'g_sb22^phi'
            write(13,102) 212,gbh124,'g_sb12^phi'
            write(13,102) 221,gbh214,'g_sb21^phi'
            end if
         endif
      endif
      !additional output
      write(13,103) 'Block MASSOUT'
      write(13,102) 1,Mh,'Mphi in GeV'
      if(yukfac(1).ne.0.d0) write(13,102) 4,mcmc,'m_c(m_c), MSbar'
      write(13,102) 5,mbmb,'m_b(m_b), MSbar'
      write(13,102) 6,mt,'m_t(pole)'
      write(13,102) 23,mZ,'m_Z'
      write(13,102) 24,mW,'m_W'
      if (pseudo.eq.0) then
         write(13,102) 25,Mh,'Mh in GeV'
      elseif (pseudo.eq.1) then
         write(13,102) 36,Mh,'MA in GeV'
      elseif (pseudo.eq.2) then
         write(13,102) 35,Mh,'MH in GeV'
      endif
      if (model.eq.1) then
         write(13,102) 1000005,Msbot1,'sbottom1 mass in GeV'
         write(13,102) 2000005,Msbot2,'sbottom2 mass in GeV'
         write(13,102) 1000006,Mstop1,'stop1 mass in GeV'
         write(13,102) 2000006,Mstop2,'stop2 mass in GeV'
         write(13,102) 1000021,Mgl,'gluino mass in GeV'
      end if

      if ((model.eq.2).and.(thdmcflag)) then
         write(13,103) 'Block 2HDMCOUT # 2HDMC results for'
         write(13,1020) 1,int(thdmcres(7))
     &        ,'stability, 0=failed, 1=ok'
         write(13,1020) 2,int(thdmcres(8)),
     &        'perturbativity, 0=failed, 1=ok'
         write(13,1020) 3,int(thdmcres(9))
     &        ,'unitarity, 0=failed, 1=ok'
         write(13,102) 7,thdmcres(11),'h width in GeV'
         write(13,102) 8,thdmcres(12),'H width in GeV'
         write(13,102) 9,thdmcres(13),'A width in GeV'      
      end if
      if ((model.eq.1).and.(fhflag)) then
         write(13,103) 'Block ALPHA # Higgs mixing parameter from FH'
         write(13,107) alpha,'alpha'
      end if

      if (model.eq.1) then
         write(13,103) 'Block STOPMIX # stop mixing matrix'
         write(13,108) 1,1,cthetat,'V_11'
         write(13,108) 1,2,sthetat,'V_12'
         write(13,108) 2,1,-sthetat,'V_21'
         write(13,108) 2,2,cthetat,'V_22'
         write(13,103) 'Block SBOTMIX # sbottom mixing matrix'
         write(13,108) 1,1,cthetab,'V_11'
         write(13,108) 1,2,sthetab,'V_12'
         write(13,108) 2,1,-sthetab,'V_21'
         write(13,108) 2,2,cthetab,'V_22'
         write(13,103) 'Block AD'
         write(13,108) 3,3,Ab
     &        ,'used Ab in GeV - def. accord. to scheme'
         write(13,103) 'Block AU'
         write(13,108) 3,3,At,'used At in GeV'
      endif
      
      write(13,103) 'Block INTERNALMASSES # Masses in GeV'
      if(yukfac(1).ne.0.d0) write(13,102) 40,mcos,'m_c(pole)'
      write(13,102) 50,mbmb,'m_b(m_b), MSbar'
      write(13,102) 51,mbMSbarmuR ,'m_b(mu_R) MSbar'
      write(13,102) 52,mbOS       ,'m_b(pole)'
      write(13,102) 53,mb
     &     ,'m_b used for internal masses'
      if (tanbresum.eq.1) then
         write(13,102) 54,mbyuk/(1+delmb)
     &        ,'m_b for bottom Yukawa'
      else if (tanbresum.eq.2) then
         if (pseudo.eq.1) then
            write(13,102) 54,mbyuk* (1.d0 - (1.d0/tanb
     &           **2)*delmb)* (1.d0/(1.d0+delmb))
     &           ,'m_b for bottom Yukawa'
         else if (pseudo.eq.0) then
            write(13,102) 54,mbyuk* (1.d0 - (1.d0/(tanb
     &           *Tan(alpha)))*delmb)* (1.d0/(1.d0
     &           +delmb)),'m_b for bottom Yukawa'
         else if (pseudo.eq.2) then
            write(13,102) 54,mbyuk* (1.d0 + (Tan(alpha)
     &           /tanb)*delmb)* (1.d0/(1.d0+delmb))
     &           ,'m_b for bottom Yukawa'
         end if 
      else
         write(13,102) 54,mbyuk
     &           ,'m_b for bottom Yukawa'
      endif
      if (model.eq.1) then
         write(13,102) 55,mbsb     ,'m_b for sbottom sector'
      endif
      write(13,103) 'Block ALPHASOUT # values from LHAPDF set'
      if (scalespt) then
         if (norderggh.ge.1) then
            write(13,102) 2,awithpt,
     &           'alpha_s(muR)@NLO'
            write(13,102) 20,awopt,
     &           'alpha_s(muR(w/o)pt)@NLO'
         endif
      else
         if (norderggh.eq.0) then
            write(13,102) 1,alphamur,'alpha_s(muR)@LO'
         endif
         if (norderggh.ge.1) then
            write(13,102) 2,alphamur,'alpha_s(muR)@NLO in ggh'
         endif
         if (norderbbh.ge.0) then
            write(13,102) 11,apimurbbh*pi,'alpha_s(muR) in '//bbhstring
         endif
         
         if (.not.((dist.ge.1).or.(ptcut).or.(rapcut))) then
            if (norderggh.ge.2) then
               write(13,102) 3,apimur*pi,'alpha_s(muR)@NNLO'
            end if
         end if
         
      end if

      if(citations(31).gt.0) then
         write(13,103) 'Block HiggsBoundsResults # HiggsBounds output'
         write(13,1021) 1,HB_chan,'most sensitive channel '//
     &        '(see Key.dat)'
         write(13,1021) 2,HB_result,'result flag (1: allowed, 0: '//
     &        'excluded, -1: unphysical)'
         write(13,102) 3,HB_obsratio,'ratio [sig x BR] model/[sig x '//
     &        'BR] limit (< 1: allowed, > 1: excluded)'
         write(13,1021) 4,HB_ncombined,'number of Higgs bosons '//
     &        'combined for most sensitive channel'
      endif

      if(citations(34).gt.0) then
         write(13,103) 'Block HiggsSignalsResults # HiggsSignals output'
         write(13,1021) 2,1,'Chi-squared method (1:peak-c, '//
     &        '2:mass-c, 3:both)'
         write(13,1021) 3,2,'Higgs mass pdf (1:box, 2:Gaussian, '//
     &        '3:box+Gaussian)'
         write(13,1021) 7,HS_nobs,'Total number of observables'
         write(13,102) 8,HS_Chisq_mu,'Chi^2 contr. from signal '//
     &        'strength observables'
         write(13,102) 9,HS_Chisq_mh,'Chi^2 contr. from mass '//
     &        'observables'
         write(13,102) 12,HS_Chisq,'Total Chi^2'
         write(13,102) 13,HS_Pvalue,'Probability (total Chi^2, '//
     &        'total number observables)'
      endif

      write(13,103)
     &     "#--------------------------------------------------#"
      write(13,103)
     &     "# Reconstructed input file of this run             #"
      write(13,103)
     &     "#--------------------------------------------------#"
      
!Reproduction of the input file
      write(13,103) 'Block SUSHI'
      write(13,1020) 1,model,'Chosen model: 0=SM, 1=MSSM, 2=2HDM'
      write(13,1020) 2,pseudo,'Chosen Higgs particle: 0=h, 1=A, 2=H'
      if (ppcoll) then
         write(13,1020) 3,0,'Particle collider: 0=pp, 1=ppbar'
      else
         write(13,1020) 3,1,'Particle collider: 0=pp, 1=ppbar'
      end if
      write(13,102)  4,cme,'center-of-mass energy in GeV'
      write(13,1020) 5,norderggh,'Order for ggh'
      if (lcchkey) then
         write(13,1020) 6,norderbbh+10,'Order for '//bbhstring//'+10'
      else
         write(13,1020) 6,norderbbh,'Order for '//bbhstring
      endif
      write(13,1020) 7,ew,'Electroweak contributions to ggh'
      write(13,1020) 19,verbose
     &     ,'0 = silent mode of SusHi, 1 = normal output'
      write(13,1020) 20,nsubprocggh
     &     ,'ggh@nnlo subprocesses: 0=all, 10=ind. contributions'
      if ((model.eq.2).and.(thdmcflag.eqv.(.false.))) then
         write(13,103) 'Block 2HDM'
         write(13,1070) twohdmver,'2HDM type'
      end if
      if (thdmcflag) then
         write(13,103) 'Block 2HDMC'
         write(13,1020) 1,thdmckey,'parametrization of 2HDM'
         write(13,1020) 2,twohdmver,'2HDM type'
         write(13,1020) 10,thdmcbreak
     &        ,'[1/0] do /not ignore validity checks'
         if (thdmckey.eq.1) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 4,thdmcm12,'m12'
            write(13,102) 11,tparam(1),'lambda1'
            write(13,102) 12,tparam(2),'lambda2'
            write(13,102) 13,tparam(3),'lambda3'
            write(13,102) 14,tparam(4),'lambda4'
            write(13,102) 15,tparam(5),'lambda5'
            write(13,102) 16,tparam(6),'lambda6'
            write(13,102) 17,tparam(7),'lambda7'
         else if (thdmckey.eq.2) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 4,thdmcm12,'m12'
            write(13,102) 21,tparam(1),'mh'
            write(13,102) 22,tparam(2),'mH'
            write(13,102) 23,tparam(3),'mA'
            write(13,102) 24,tparam(4),'mC'
            write(13,102) 25,tparam(5),'sin(beta-alpha)'
            write(13,102) 26,tparam(6),'lambda6'
            write(13,102) 27,tparam(7),'lambda7'
         else if (thdmckey.eq.3) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 31,tparam(1),'mh'
            write(13,102) 32,tparam(2),'mH'
            write(13,102) 33,tparam(3),'sin(beta-alpha)'
            write(13,102) 34,tparam(5),'Z4'
            write(13,102) 35,tparam(6),'Z5'
            write(13,102) 36,tparam(7),'Z7'
         else
            call printdie('thdmckey not implemented')
         endif
      endif
      write(13,103) 'Block SMINPUTS'
       write(13,102) 1,invAlfa,'1/alpha_em(MZ) SM MSbar'
       write(13,102) 2,GF,'G_F'
       write(13,102) 3,AlfasMZ,'alpha_s(m_Z)'
       write(13,102) 4,mZ,'m_Z(pole)'
       write(13,102) 5,mbmb,'m_b(m_b)'
       write(13,102) 6,mt,'m_t(pole)'
       if (yukfac(1).ne.(0.d0)) write(13,102) 8,mcmc,'m_c(m_c)'
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &(model.eq.1)) then
      write(13,103) 'Block MINPAR'
       write(13,102) 3,tanb,'tan(beta)'
      end if
      !Specific SUSY parameters
      if (model.eq.1) then
      write(13,103) 'Block EXTPAR'
       write(13,102) 3,mgl,'Gluino mass'
       write(13,102) 11,Real(cAt),'A_t'
       write(13,102) 12,Real(cAb),'A_b'
       write(13,102) 23,muSUSY,'mu'
       if (fhflag) write(13,102) 26,mA0,'mA'
       write(13,102) 43,M3SQ,'M3SQ'
       write(13,102) 46,M3SU,'M3SU'
       write(13,102) 49,M3SD,'M3SD'
      if (fhflag) then
      write(13,103) 'Block FEYNHIGGS'
       write(13,102) 1,Real(M_1),'M1'
       write(13,102) 2,Real(M_2),'M2'
       write(13,102) 13,Real(cAtau),'A_tau'
       write(13,102) 14,Real(cAc),'A_c'
       write(13,102) 15,Real(cAs),'A_s'
       write(13,102) 16,Real(cAmu),'A_mu'
       write(13,102) 17,Real(cAu),'A_u'
       write(13,102) 18,Real(cAd),'A_d'
       write(13,102) 19,Real(cAe),'A_e'
       write(13,102) 31,M1SL,'M1SL'
       write(13,102) 32,M2SL,'M2SL'
       write(13,102) 33,M3SL,'M3SL'
       write(13,102) 34,M1SE,'M1SE'
       write(13,102) 35,M2SE,'M2SE'
       write(13,102) 36,M3SE,'M3SE'
       write(13,102) 41,M1SQ,'M1SQ'
       write(13,102) 42,M2SQ,'M2SQ'
       write(13,102) 44,M1SU,'M1SU'
       write(13,102) 45,M2SU,'M2SU'
       write(13,102) 47,M1SD,'M1SD'
       write(13,102) 48,M2SD,'M2SD'
      end if
      end if
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &((model.eq.1).and.(fhflag.eqv.(.false.)))) then
       write(13,103) 'Block ALPHA # Higgs mixing parameter'
       write(13,107) alpha,'alpha'
      end if
      if (model.eq.0) then
      write(13,103) 'Block MASS'
       write(13,102) 25,Mh,'Higgs mass'
      end if
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &((model.eq.1).and.(fhflag.eqv.(.false.)))) then
      write(13,103) 'Block MASS'
        if (pseudo.eq.0) write(13,102) 25,Mh,'Light Higgs mass'
        if (pseudo.eq.1) write(13,102) 36,Mh,'Pseudoscalar Higgs mass'
        if (pseudo.eq.2) write(13,102) 35,Mh,'Heavy Higgs mass'
      end if
      !only write relevant DISTRIBUTION input
      write(13,103) 'Block DISTRIB'
       if (dist.eq.0) then
        resstring = 'total XS'
       else if (dist.eq.1) then
        resstring = 'diff. XS dsigma/dpt'
       else if (dist.eq.2) then
        resstring = 'diff. XS dsigma/dy'
        if (pseudorap) resstring = 'diff. XS dsigma/deta'
       else if (dist.eq.3) then
        resstring = 'diff. XS dsigma/dy/dpt'
        if (pseudorap) resstring = 'diff. XS dsigma/deta/dpt'
       end if
      write(13,1020) 1,dist,resstring
      if (ptc.eq.0) then
       if ((dist.eq.1).or.(dist.eq.3))
     & write(13,102) 22,pt,'pt in GeV (for diff. XS evaluation)'
      else if (ptc.ge.1) then
       write(13,1020) 2,ptc,'pt cut'
       if (ptc.eq.1) then
       write(13,102) 21,minptc,'Minimal pt value in GeV'
       else if (ptc.eq.2) then
       write(13,102) 22,maxptc,'Maximal pt value in GeV'
       else if (ptc.eq.3) then
       write(13,102) 21,minptc,'Minimal pt value in GeV'
       write(13,102) 22,maxptc,'Maximal pt value in GeV'
       end if
      end if
      if (pseudorap) then
       if (rapc.eq.0) then
        if ((dist.eq.2).or.(dist.eq.3))
     &    write(13,102) 32,y,'eta (for diff. XS evaluation)'
       else if (rapc.ge.1) then
          write(13,1020) 3,rapc,'eta cut'
          if (rapc.eq.2) then
          write(13,102) 31,minrap,'Minimal eta value'
          else if (rapc.eq.1) then
          write(13,102) 32,maxrap,'Maximal eta value'
          else if (rapc.eq.3) then
          write(13,102) 31,minrap,'Minimal eta value'
          write(13,102) 32,maxrap,'Maximal eta value'
          end if
       end if
      else
       if (rapc.eq.0) then
        if ((dist.eq.2).or.(dist.eq.3))
     &    write(13,102) 32,y,'y (for diff. XS evaluation)'
       else if (rapc.ge.1) then
          write(13,1020) 3,rapc,'y cut'
          if (rapc.eq.2) then
          write(13,102) 31,minrap,'Minimal y value'
          else if (rapc.eq.1) then
          write(13,102) 32,maxrap,'Maximal y value'
          else if (rapc.eq.3) then
          write(13,102) 31,minrap,'Minimal y value'
          write(13,102) 32,maxrap,'Maximal y value'
          end if
       end if
      end if

      if (pseudorap) write(13,1020) 4,1,'Pseudorapidity'

      write(13,103) 'Block SCALES'
      if (scalespt) then
         write(13,102) 1,muRfactor,
     &        'Renormalization scale muR/Sqrt(mh^2+pt^2)'
         write(13,102) 2,muFfactor,
     &        'Factorization scale muF/Sqrt(mh^2+pt^2)'
         write(13,1020) 3,1,'Use p_t dependent scale choice'
      else
         write(13,102) 1,muR/mh,'Renormalization scale muR/mh'
         write(13,102) 2,muF/mh,'Factorization scale muF/mh'
         write(13,102) 11,murfacbbh
     &        ,'Renormalization scale muR/mh for '//bbhstring
         write(13,102) 12,muffacbbh,'Factorization scale muF/mh for '
     &        //bbhstring
      end if
      write(13,103) 'Block RENORMBOT'
       write(13,1020) 1,mbrunyuk,'mb used for bottom Yukawa'
      if (model.eq.1) then
       write(13,1020) 2,tanbresum,'Resummation of sbottom effects'
       write(13,1020) 3,delmbfh,'Delta_b from FeynHiggs'
      end if
      if (mbossave.gt.0.D0)
     &write(13,102) 4,mbossave,'Fixed m_b(pole) in GeV'
      if (model.eq.1) then
      write(13,103) 'Block RENORMSBOT'
       write(13,1020) 1,mbsbch,'Renormalization of m_b'
       write(13,1020) 2,Abch,'Renormalization of A_b'
       write(13,1020) 3,thetabch,'Renormalization of theta_b'
      end if
      write(13,103) 'Block PDFSPEC'
       write(13,1022) 1,SUpdfs(1),'LO   PDF set'
       write(13,1020) 11,SUiset(1),'LO PDF set number'
       write(13,1022) 2,SUpdfs(2),'NLO  PDF set'
       write(13,1020) 12,SUiset(2),'NLO PDF set number'
       write(13,1022) 3,SUpdfs(3),'NNLO PDF set'
       write(13,1020) 13,SUiset(3),'NNLO PDF set number'
      write(13,103) 'Block VEGAS'
      write(13,103) '# parameters for NLO SusHi'
       write(13,1021) 1,ncall1sushi,'Number of points'
       write(13,1021) 2,itmx1sushi,'Number of iterations'
       if (lveg1sushi) then
          write(13,1021) 11,ncall2sushi,'Number of points in second run'
          write(13,1021) 12,itmx2sushi
     &         ,'Number of iterations in second run'
       endif
       write(13,1021) 3,nprnvsushi,'Output format of VEGAS integration'
       write(13,103) '# parameters for ggh@nnlo:'
       write(13,1021) 4,ncall1ggh,'Number of points'
       write(13,1021) 5,itmx1ggh,'Number of iterations'
       if (lveg1ggh) then
          write(13,1021) 14,ncall2ggh,'Number of points in second run'
          write(13,1021) 15,itmx2ggh
     &         ,'Number of iterations in second run'
       endif
       write(13,1021) 6,nprnvggh,'Output format of VEGAS integration'
       write(13,103) '# parameters for bbh@nnlo:'
       write(13,1021) 7,ncall1bbh,'Number of points'
       write(13,1021) 8,itmx1bbh,'Number of iterations'
       if (lveg1bbh) then
          write(13,1021) 17,ncall2bbh,'Number of points in second run'
          write(13,1021) 18,itmx2bbh
     &         ,'Number of iterations in second run'
       endif
       write(13,1021) 9,nprnvbbh,'Output format of VEGAS integration'
      write(13,103) 'Block FACTORS'
       write(13,102) 1,yukfac(1),
     &'Factor multiplied with Yukawa of c quark'
       write(13,102) 2,yukfac(2),'t quark'
       write(13,102) 3,yukfac(3),'b quark'
       if (model.eq.1) then
       write(13,102) 4,yukfac(6),'top squark'
       write(13,102) 5,yukfac(7),'bottom squark'
       end if

      !call filedump(12,13)
      write(13,103)
     &"#--------------------------------------------------#"
      write(13,103) 
     &"# End of SusHi output                              #"
      write(13,103)
     &"#--------------------------------------------------#"

      close(12)
      close(13)

 102  format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 1020 format(1x,I9,3x,1P,i2.1,0P,3x,'#',1x,A)
 1021 format(1x,I9,3x,1P,i6.1,0P,3x,'#',1x,A)
 1022 format(1x,I9,3x,1P,A45,0P,3x,'#',1x,A)
 1023 format(1x,I9,3x,1P,A10,0P,3x,'#',1x,A)
 103  format(a)
 105  format('#--------------------------------------------------#')
 106  format ('# Date: ',i2.2,'.',i2.2,'.',i4.4,' at ',
     &i2.2,':',i2.2,':',i2.2,'                     #')
 107  format(9x,1P,E16.8,0P,3x,'#',1x,A)
 1070 format(9x,1P,i2.1,0P,3x,'#',1x,A)
 108  format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)

      end

C-}}}
C-{{{ subroutine screenoutputsushi

      subroutine screenoutputsushi()

      implicit none
      character hepunit*10,bbhstring*3

      include '../commons/common-inputoutput.f'
      !internal definitions

!defined at other places:
!AlfasMZ,muRfactor,muFfactor,cme,dist,prefix,prefix2,pty,iset
!norder,mw,mc,ew,mz,mbmb,renscheme,mt,pseudo,tanbresum,pseudorap
      include '../commons/common-keys.f'
      include '../commons/common-slha.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'
      include '../commons/common-ren.f'
      include '../commons/common-quark.f'
      include '../commons/common-int.f'

      bbhstring='bbh'
      if (lcchkey) bbhstring='cch'

      if ((norderggh.eq.0).and.(ew.ge.1)) then
            write(*,105)
            write(*,*) 
     &"Note: At LO electroweak contributions for ggh are not given."
            write(*,105)
      endif

      if (((dist.ge.1).or.(ptcut.or.rapcut)).and.(ew.eq.2)) then
            write(*,105)
            write(*,*) 
     &"Note: The SM electroweak factor is not applicable"
            write(*,*) "for cuts and distributions."
            write(*,105)
      endif

      if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
            write(*,105)
            write(*,*) 
     &"Note: Fixed order p_T distribution (no resummation)!"
            write(*,*) "p_T < 20 GeV not reasonable."
            write(*,105)
      endif

      if (norderggh.ge.2) then
         if (dist.ne.0) then
            write(*,105)
            write(*,*) 
     &"Note: Differential cross sections for ggh are not available ",
     &"at NNLO."
            write(*,*) 
     &"Thus only NLO results will be given."
            write(*,105)
         elseif (ptcut.or.rapcut) then
            write(*,105)
            write(*,*) 
     &"Note: Cuts can only be applied at NLO for ggh."
            write(*,*) 
     &"Thus NNLO weighted results will not be given."
            write(*,105)
         elseif (model.eq.1) then
            if(norderggh.eq.2) then
               write(*,105)
               write(*,*) 
     &"Note: NNLO SUSY contribution not taken into account."
               write(*,*) 
     &"Use order ggh = 3 for approximate NNLO stop cont. for h."
               write(*,105)
            else
               write(*,105)
               write(*,*) 
     &"Note: Using approximate NNLO top+stop contributions."
               write(*,*) 
            endif
         endif
      endif
      if (norderbbh.ge.0) then
         if (dist.gt.0) then
            write(*,105)
            write(*,*) 
     &           "Note: Differential cross sections for "//bbhstring/
     &           /" are not available."
            write(*,*) 
     &"However cuts for the total cross sections can be set!"
            write(*,105)
         endif
         if ((dist.eq.0).and.(norderbbh.eq.2)) then
         if (ptcut.or.rapcut) then
            write(*,105)
            write(*,*) 
     &"Note: Cuts can only be applied at NLO for "//bbhstring//"."
            write(*,*) 
     &"Thus NNLO results will not be given."
            write(*,105)
         endif
         endif
      end if

      if ((dist.eq.0).or.(dist.eq.2)) then
         hepunit = "   pb"
      else
         hepunit = "   pb/GeV"
      end if

      if (norderbbh.ge.0) then
         if (dist.eq.0) then
            write(*,105)
            write(*,107) " The "//bbhstring//" results are given by:"
            if ((ptc.eq.0).and.(rapc.eq.0)) then
            write(*,108) "LO: ",SUbbh(1)
            else
            write(*,106) "LO: ",SUbbh(1),SUbbherr(1),hepunit
            end if
            if (norderbbh.gt.0) then
               if ((ptc.eq.0).and.(rapc.eq.0)) then
               write(*,108) "NLO: ",SUbbh(2)
               else
               write(*,106) "NLO: ",SUbbh(2),SUbbherr(2),hepunit
               end if
            end if
            if (norderbbh.gt.1) then
            if (.not.((ptc.gt.0).or.(rapc.gt.0))) then
               write(*,108) "NNLO: ",SUbbh(3)
            end if
            end if
         end if
      end if

      if (norderggh.ge.0) then
         write(*,105)
         write(*,107) " The ggh results are given by:"
         write(*,106) "LO: ",xsec(1),xsecerr(1),hepunit
         if (norderggh.gt.0) then
            write(*,106) "gg: ",ggchan,ggchanerr,hepunit
            write(*,106) "qg: ",qgchan, qgchanerr,hepunit
            write(*,106) "qq: ",qqchan, qqchanerr,hepunit
            write(*,106) "NLO: ",xsec(2),xsecerr(2),hepunit
!            if ((dist.eq.0).and.((ew.ge.1).or.(norderggh.ge.2))) then
            if (((ew.ge.1).or.(norderggh.ge.2))
     &.and.(((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0)).or.(ew.eq.1)))
     & then
            write(*,106) "xsec: ",xeff,xefferr,hepunit
               write(*,107)
     &" Details with respect to the weighted result in output-file."
            end if
         end if
      end if

      write(*,105)

 105  format('#--------------------------------------------------#')
 106  format(a11,'    ',f10.5,'   +-',f10.5,a10)
 107  format(a)
 108  format(a11,'    ',f10.5, '   pb')

      end
C-}}}
C-{{{ function mapreal8:

      real*8 function mapreal8(val,lval,message)

      implicit real*8(a-z)
      character(*) message
      logical lval

      if (lval) then
         mapreal8 = val
      else
         mapreal8 = -12345678901234567890.d0
         call printdie(message)
      endif

      return
      end

C-}}}
C-{{{ function mapreal8def:

      real*8 function mapreal8def(val,lval,default,message)

      real*8 default,val
      character(*) message
      logical lval

      if (lval) then
         mapreal8def = val
      else
         mapreal8def = default
         call printinfosushi(6,message)
      endif

      return
      end

C-}}}
C-{{{ function mapint:

      integer function mapint(val,lval,message)

      implicit real*8(a-z)
      integer val
      character(*) message
      logical lval

      if (lval) then
         mapint = val
      else
         call printdie(message)
      endif

      return
      end

C-}}}
C-{{{ function mapintdef:

      integer function mapintdef(val,lval,default,message)

      integer default,val
      character(*) message
      logical lval

      if (lval) then
         mapintdef = val
      else
         mapintdef = default
         call printinfosushi(6,message)
      endif

      return
      end

C-}}}
C-{{{ subroutine filedump:

      subroutine filedump(iunitin,iunitout)
c..
c..   Write file unit=iunitin into file unit=iunitout.
c..   Both files must be open before calling filedump,
c..   and both files will be at EOF after calling filedump.
c..
      integer iunitin,iunitout
      character*200 achar

      rewind(iunitin)
 201  read(iunitin,1112,END=202) achar
      length = lnblnk(achar)
      write(iunitout,1112) achar(1:length)
      goto 201
 202  continue

 1112 format(a)

      end

C-}}}
C-{{{ subroutine printdie:

      subroutine printdie(strng)

      character*(*) strng

      write(6,*) 'SusHi (fatal): ',strng,' Stopped.'
      stop

      end

C-}}}
C-{{{ subroutine printcopysushi:

      subroutine printcopysushi(fullflag,iu,verbose)

      integer fullflag, iu, verbose

      include '../commons/common-inputoutput.f'

      if (verbose.ne.0) then
      write(iu,1) "#--------------------------------------------------#"
      write(iu,1) "# SusHi: Supersymmetric Higgs production through   #"
      write(iu,1) "#  __      __        gluon fusion and bottom-quark #"
      write(iu,1) "# [_  | | [_  |_| |  annihilation                  #"
      write(iu,1) "# __] |_| __] | | |                                #"
      write(iu,1) '#                    Version '//SUversion//SUdate//
     & '  #'
      if (fullflag.eq.1) then
      write(iu,1) "#        R. Harlander, S. Liebler, and H. Mantler  #"
      write(iu,1) "#             (harlander@physik.uni-wuppertal.de)  #"
      write(iu,1) "#                        (stefan.liebler@desy.de)  #"
      write(iu,1) "#                              (hmantler@cern.ch)  #"
      write(iu,1) "#       Bergische Universitaet Wuppertal, Germany  #"
      write(iu,1) "#--------------------------------------------------#"
      write(iu,1) "# SusHi is based on a number of calculations       #"
      write(iu,1) "# due to various groups. Please acknowledge these  #"
      write(iu,1) "# efforts by citing the list of references which   #"
      write(iu,1) "# are included in the output file of every run.    #"
      end if
      write(iu,1) "#--------------------------------------------------#"
      endif

 1    format(a)
      
      end

C-}}}
C-{{{ subroutine printwarnsushi:

      subroutine printwarnsushi(verb,unit,strng)

      integer unit,verb
      character*(*) strng

      if (verb.ne.0) write(unit,*) 'SusHi (warning): ',strng

      end

C-}}}
C-{{{ subroutine printinfosushi:

      subroutine printinfosushi(unit,strng)

      integer unit,verb
      character*(*) strng
      include '../commons/common-keys.f'
      
      if (verbose.ne.0) write(unit,*) 'SusHi (info): ',strng

      end

C-}}}
C-{{{ subroutine printerrorsushi:

      subroutine printerrorsushi(verb,unit,strng)

      integer unit,verb
      character*(*) strng

      if (verb.eq.1) write(unit,*) 'SusHi (error): ',strng
      stop

      end

C-}}}
